/***************************************************/
/* Last Revised:
$Id: IntMatND.h,v 1.2 2004/02/11 21:12:49 jminguez Exp jminguez $
*/
/***************************************************/

/* 
 Este fichero hace la interfaz entre el programa y el ND  
*/

#ifndef InfMatND_H
#define InfMatND_H

#include "TData.h"
#include "nd.h"
#include "Matriz.h"

/**************** ********* ***************/
/**************** FUNCIONES ***************/
/**************** ********* ***************/

/* --------------------------------------------------------------------------------------- */
/* InitMatND                                                                               */ 
/*  .... Funcion de inicio del ND                                                          */ 
/*  .... In: La estructura de parametros a iniciar del ND                                  */ 
/*  .... Out: La estrucura inicializada (tamanio robot y velocidades y aceleraciones       */

void InitMatND (TParametrosND *NDparametros);


/* --------------------------------------------------------------------------------------- */
/* ComputaMapa                                                                             */ 
/*  .... Extrae de la matriz la nube de puntos para el ND                                  */ 
/*  .... In: La matriz y los sitemas de referencia de la matriz y del robot                */ 
/*  .... Out: La nube de puntos alacenada en la estructura entorno                         */

void ComputaMapa(float mapa[][DIMMATRIZ],
		 Tsc *sisMat, 
		 Tsc *sisrob,
		 TInfoEntorno *entorno,
		 Tscan *scan) ;



#endif
