/***************************************************/
/* Last Revised:
$Id: InitMatSM.h,v 1.2 2004/02/11 21:12:49 jminguez Exp jminguez $
*/
/***************************************************/

/* 
   Este fichero contiene las funciones para trabajar con el ScanMatching
*/


#ifndef IntSM
#define IntSM

#include "TData.h"
#include "Matriz.h"

/**************** ********* ***************/
/**************** FUNCIONES ***************/
/**************** ********* ***************/

/* --------------------------------------------------------------------------------------- */  
/* TRABAJO CON EL SCANMATCHING                                                             */
/* --------------------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------------------- */
/* InitScanMatching                                                                        */ 
/*  .... inicializa todo lo necesario para utilizar el Scan                                */ 
/*  .... In: la matriz a iniciar y el sistema del robot actual                             */ 
/*  .... Out: la matriz iniciada, y el sistema de la matriz con el robot en el centro      */

void InitScanMatching();

/* --------------------------------------------------------------------------------------- */
/* ScanMatching                                                                            */ 
/*  .... Funcion para utilizar el ScanMatching. Si es la primera vez que se utiliza        */
/*       no hace nada, y luego con las anteriores hace el SM                               */ 
/*  .... In: la matriz, y el sistema de referencia de la matriz (glob),                    */
/*       el Scan y la odometria (glob), flagM si 1 hace el scan con el mapa y 0 con laser  */                     /*  .... Out: en Srobot devuelve la nueva posicion en coordenadas globales                 */

int ScanMatching(float a[][DIMMATRIZ], Tsc *Smatriz,
		  Tscan *ptos, Tsc *Srobot, Tsc *Srobot_k1,
		  int flagMapa);

#endif
