/***************************************************/
/* Last Revised:
$Id: Laser.c,v 1.1 2004/02/11 20:28:35 jminguez Exp jminguez $
*/
/***************************************************/

#include <stdio.h>

#include "calcul.h"
#include "Matriz.h"

#include "Bresenham.h"
#include "Bresenham.c"

#include <math.h>
#include "Laser.h"
#include "geometria.h"

/* ************************************************************************ */
/* ****************** DEFINICION DE LAS VARIABLES ************************* */
/* ************************************************************************ */

Tsc PosSensorRobot;

//static float cosAng[361];
//static float sinAng[361];
 
/* ************************************************************************ */
/* ****************** DEFINICION DE LAS FUNCIONES ************************* */
/* ************************************************************************ */

void InitLaser(){

  //int i;

  printf("-- Initiating Laser .");
  
//  for (i=0;i<NUMPUNTOSLASER;i++){
//    cosAng[i]=(float)cos(PI/360*i-PI/2.0); /* Los cos y sen se pueden precomp */
//    sinAng[i]=(float)sin(PI/360*i-PI/2.0);
//  }

  printf(".");
  
  PosSensorRobot.x=POSxSENSOR;
  PosSensorRobot.y=POSySENSOR;
  PosSensorRobot.tita=POStSENSOR;
  

  printf(" OK! \n");

}

void ProyectaLaser2Matriz(float a[][DIMMATRIZ],
			  Tscan *staticPt,
			  Tscan *movingPt,
			  Tscan *unknownPt,
			  Tscan *outPt,
			  Tsc *Srobot, 
			  Tsc *Smatriz){
  
  Tsc sisOut,sisMatRob,sisMatSensor;
  Tpf sol2,sol3,sol5;
  Tpcelda out1,out2;
  int dentro;
  int i;
  short tag;

  inversion_sis(Smatriz,&sisOut);
  composicion_sis(&sisOut,Srobot,&sisMatRob);
  composicion_sis(&sisMatRob,&PosSensorRobot,&sisMatSensor);

  transfor_directa_p (0.0,0.0,&sisMatSensor,&sol2 );
  SisM2celda(&sol2,&out2);

  // Static Points
  for (i=0; i<staticPt->numPuntos; i++) {
	  tag=SPT;
	  transfor_directa_p (staticPt->laserC[i].x, staticPt->laserC[i].y, &sisMatRob,&sol3);
	  SisM2celda(&sol3,&out1);
	  
	  dentro = CeldaInMatriz(&out1);
      if (!dentro){
		  RecomputaPuntoFinal(&sol2,&sol3,&sol5);
		  SisM2celda(&sol5,&out1);      
		  tag=MPT;
      }
      
      LineBresenham(out2.fil,out2.col,out1.fil,out1.col,a,tag);
  }

  // Moving Points
  tag=MPT;
  for (i=0; i<movingPt->numPuntos; i++) {	  
	  transfor_directa_p (movingPt->laserC[i].x, movingPt->laserC[i].y, &sisMatRob,&sol3);
	  SisM2celda(&sol3,&out1);
	  
	  dentro = CeldaInMatriz(&out1);
      if (!dentro){
		  RecomputaPuntoFinal(&sol2,&sol3,&sol5);
		  SisM2celda(&sol5,&out1);      		  
      }
      
      LineBresenham(out2.fil,out2.col,out1.fil,out1.col,a,tag);         
  }
  
  // Unknown Points
  tag=UPT;
  for (i=0; i<unknownPt->numPuntos; i++) {
	  transfor_directa_p (unknownPt->laserC[i].x, unknownPt->laserC[i].y, &sisMatRob,&sol3);
	  SisM2celda(&sol3,&out1);
	  
	  dentro = CeldaInMatriz(&out1);
      if (!dentro){
		  RecomputaPuntoFinal(&sol2,&sol3,&sol5);
		  SisM2celda(&sol5,&out1);      
		  tag=MPT;
      }
      
      LineBresenham(out2.fil,out2.col,out1.fil,out1.col,a,tag);          
  }

  // out Points
  tag=MPT;
  for (i=0; i<outPt->numPuntos; i++) {
	  transfor_directa_p (outPt->laserC[i].x, outPt->laserC[i].y, &sisMatRob,&sol3);
	  SisM2celda(&sol3,&out1);
	  
	  dentro = CeldaInMatriz(&out1);
      if (!dentro){
		  RecomputaPuntoFinal(&sol2,&sol3,&sol5);
		  SisM2celda(&sol5,&out1);      
      }
      
      LineBresenham(out2.fil,out2.col,out1.fil,out1.col,a,tag);      
  }
}
