/***************************************************/
/* Last Revised:
$Id: lista.h,v 1.2 2004/02/11 21:12:49 jminguez Exp jminguez $
*/
/***************************************************/

/* 
   Este fichero contiene las utilidades referentes a listas dinamicas.
*/

#ifndef lista_h
#define lista_h

#include "TData.h"

/**************** ********* ***************/
/**************** DATOS     ***************/
/**************** ********* ***************/

typedef struct{
  int etiquetaPunt;
  int etiqueta;
  float distGoal;
  Tpf punto;
  void *next;
}Tnodo;

/**************** ********* ***************/
/**************** FUNCIONES ***************/
/**************** ********* ***************/

/* --------------------------------------------------------------------------------------- */  
/* MANIPULACION DE LA LISTA                                                                */
/* --------------------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------------------- */
/* CrearLista                                                                              */ 
/*  .... Inicia la lista                                                                   */ 
/*  .... In: ---                                                                           */ 
/*  .... Out: ---                                                                          */
/*  .... Return: devuelve un puntero al primer elemento de la lista NULL                   */

void *CrearLista();

/* --------------------------------------------------------------------------------------- */
/* EliminarLista                                                                           */ 
/*  .... Vacia la lista liberando toda la memoria ocupada por sus nodos                    */ 
/*  .... In: puntero a la lista                                                            */ 
/*  .... Out: el puntero apuntando a NULL con todo liberado                                */

void EliminarLista(Tnodo **lista);

/* --------------------------------------------------------------------------------------- */
/* PrintLista                                                                              */ 
/*  .... Saca por pantalla todos los componentes de la lista                               */ 
/*  .... In: puntero al primer elemento de la lista                                        */ 
/*  .... Out: ---                                                                          */

void PrintLista(Tnodo *lista);


/* --------------------------------------------------------------------------------------- */
/* ListaVacia                                                                              */ 
/*  .... Dice si la lista esta vacia                                                       */ 
/*  .... In: puntero al primer elemento de la lista                                        */ 
/*  .... Out: ---                                                                          */
/*  .... Return: devuelve 1 si esta vacia y 0 en caso contrario                            */

int ListaVacia(Tnodo *lista);



void InsertarLista(Tnodo **lista, Tpf *punto, 
		   float valor, int etiquetaPunt, int etiqueta);

int SacarLista(Tnodo **lista,Tpf *elem,int *etiquetaPunt, float *valor);

float LeerDistanciaPrimero(Tnodo *lista);
int LeerElementoX(Tnodo *lista,int xin, Tpf *elem, int *etiqueta, int *etiquetaPunt);
int LeerElementoEtiqueta(Tnodo *lista,int etiqueta, Tpf *elem, int *etiquetaPunt);

/* ---------------------------- */


#endif
