/***************************************************/
/* Last Revised:
$Id: lista.h,v 1.2 2004/02/11 21:12:49 jminguez Exp jminguez $
*/
/***************************************************/

/* 
   Este fichero contiene las utilidades referentes a listas dinamicas.
*/

#ifndef listaKFPT_h
#define listaKFPT_h

#include "KF_Equations.h"

/**************** ********* ***************/
/**************** DATOS     ***************/
/**************** ********* ***************/

typedef struct{
  int label;		// Name		
  int sortLabel;	// label to sort the list
  Tkf filter;		// Kalman Filter
  Tpf obs;			// Last observation associated to this filter
  short numNotSeen; // Number of steps withour support
  void *next;		// Next item on the list
} TnodoKFPT;

/**************** ********* ***************/
/**************** FUNCIONES ***************/
/**************** ********* ***************/

/* --------------------------------------------------------------------------------------- */  
/* MANIPULACION DE LA LISTA                                                                */
/* --------------------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------------------- */
/* CrearLista                                                                              */ 
/*  .... Inicia la lista                                                                   */ 
/*  .... In: ---                                                                           */ 
/*  .... Out: ---                                                                          */
/*  .... Return: devuelve un puntero al primer elemento de la lista NULL                   */

void *CrearListaKFPT();

/* --------------------------------------------------------------------------------------- */
/* EliminarLista                                                                           */ 
/*  .... Vacia la lista liberando toda la memoria ocupada por sus nodos                    */ 
/*  .... In: puntero a la lista                                                            */ 
/*  .... Out: el puntero apuntando a NULL con todo liberado                                */

void EliminarListaKFPT(TnodoKFPT **lista);

/* --------------------------------------------------------------------------------------- */
/* PrintLista                                                                              */ 
/*  .... Saca por pantalla todos los componentes de la lista                               */ 
/*  .... In: puntero al primer elemento de la lista                                        */ 
/*  .... Out: ---                                                                          */

void PrintListaKFPT(TnodoKFPT *lista);


/* --------------------------------------------------------------------------------------- */
/* ListaVacia                                                                              */ 
/*  .... Dice si la lista esta vacia                                                       */ 
/*  .... In: puntero al primer elemento de la lista                                        */ 
/*  .... Out: ---                                                                          */
/*  .... Return: devuelve 1 si esta vacia y 0 en caso contrario                            */

int ListaVaciaKFPT(TnodoKFPT *lista);


void InsertarListaKFPT(TnodoKFPT **lista, Tkf *filter, int label, int sortLabel);

int SacarListaKFPT(TnodoKFPT **lista,Tkf *elem,int *label, int *sortLabel);

int LeerElementoXKFPT(TnodoKFPT *lista,int xin, Tkf *elem, int *label, int *sortLabel);
int LeerElementoEtiquetaKFPT(TnodoKFPT *lista,int label, Tkf *elem, int *sortLabel);

/* ---------------------------- */


#endif
