---------------------------------------------------------------------
-- Fichero:   comun.adb
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.1 14-3-2003
-- Proposito: Ejemplo con 3 tareas que se comunican con 2 servidores
---------------------------------------------------------------------
-- v2.0  27-3-2002  JDT
--    Cambiados los tiempos para que se vean inversiones de prioridad
--    Los servidores se pasan al paquete servidores
-- v2.1  14-3-2003  JDT
--    Se usa Ada.Real_Time en lugar de Calendar
---------------------------------------------------------------------

pragma locking_policy (ceiling_locking) ;
pragma task_dispatching_policy (fifo_within_priorities) ;
with MaRTE_OS;

with Ada.Real_Time, computos, servidores, traza, system, Ada.Text_IO; 
use  Ada.Real_Time, computos, servidores, traza, Ada.Text_IO;

procedure apartado2 is

 Package Duracion is new Fixed_IO(duration);
 use Duracion;

tinicio : constant time := clock ;
intervalo : constant Time_Span:= milliseconds(12000) ;

	procedure comun is
	t1_prioridad: constant system.any_priority:= 4;  -- poner lo adecuado
	t2_prioridad: constant system.any_priority:= 2;  -- poner lo adecuado
	t3_prioridad: constant system.any_priority:= 1;  -- poner lo adecuado
	tinicio: constant time:= clock;
	
	task t1 is pragma priority (t1_prioridad); end;
	task body t1 is
		periodo: constant Time_Span:= milliseconds(1000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(1);
		computo(0.1);		
		s1.servicio1;	
		termino(1);	
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t2 is pragma priority (t2_prioridad); end;
	task body t2 is
		periodo: constant Time_Span:= milliseconds(2000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(2);
		computo(0.50);
		s2.servicio1;
		termino(2);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t3 is pragma priority (t3_prioridad); end;
	task body t3 is
		periodo: constant Time_Span:= milliseconds(4000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(3);
		s2.servicio2;
		computo(0.30);
		s1.servicio2;
		termino(3);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	begin -- comun
	delay until(tinicio+intervalo);
	abort t1, t2, t3;
	end comun;

begin
comienzo_traza(clock);
comun;
escribe_traza(1.0);
end apartado2;