---------------------------------------------------------------------
-- Fichero:   Queue_Pkg.ads
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.0 4-4-2002
-- Proposito: Paquete generico de colas
---------------------------------------------------------------------

package body Queue_Pkg is

   Count     : Data_Item_Count := 0;  
   Out_Index : Data_Item_Index := 1;  
   In_Index  : Data_Item_Index := 1;  

   procedure Add (
         Q    : in out Queue;    
         Item :        Data_Item ) is 
   begin
      if Count >= Queue_Size then
         raise Queue_Full ;
      end if ;
      Q ( In_Index ) := Item;
      In_Index := In_Index mod Queue_Size + 1;
      Count := Count + 1;
   end Add ;

   procedure Extract (
         Q    : in out Queue;    
         Item :    out Data_Item ) is 
   begin
      if Count = 0 then
         raise Queue_Empty ;
      end if ;
      Item := Q( Out_Index );
      Out_Index := Out_Index mod Queue_Size + 1;
      Count := Count -1;
   end Extract ;

   procedure Clear (
         Q : in out Queue ) is 
   begin
      Count := 0;
      Out_Index := 1;
      In_Index := 1;
   end Clear;

   function Empty (
         Q : in     Queue ) 
     return Boolean is 
   begin
      return Count = 0 ;
   end Empty ;

end Queue_Pkg;
