---------------------------------------------------------------------
-- Fichero:   Queue_Pkg.ads
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.0 4-4-2002
-- Proposito: Paquete generico de colas
---------------------------------------------------------------------

generic
   type Data_Item is private; 
   Queue_Size : Positive;  
package Queue_Pkg is

   type Queue is limited private; 

   procedure Add (
         Q    : in out Queue;    
         Item :        Data_Item ); 
   procedure Extract (
         Q    : in out Queue;    
         Item :    out Data_Item ); 
   procedure Clear (
         Q : in out Queue ); 
   function Empty (
         Q : in     Queue ) 
     return Boolean; 

   Queue_Full: exception ;
   Queue_Empty: exception ;

private

   subtype Data_Item_Count is Integer range 0 .. Queue_Size;
   subtype Data_Item_Index is Integer range 1 .. Queue_Size;
   type Queue is array (Data_Item_Index) of Data_Item; 

end Queue_Pkg;
