/***************************************************/
/* Last Revised:
$Id: LinePl.h,v 1.2 2004/02/11 21:12:49 jminguez Exp jminguez $
*/
/***************************************************/

/* 
   Este fichero contiene todo lo relativo al planificador.
*/


#ifndef LinePl_h
#define LinePl_h

#include "TData.h"
#include "Matriz.h"
#include "lista.h"

/**************** ********* ***************/
/****************   DATOS   ***************/
/**************** ********* ***************/

#define SECTORES_PL 360
#define PLAN_TIME_UP 50 // mseg

/* Tpf Obst1sectoriz[SECTORES]; */

extern Tnodo * listaExpandida; /* Estan fuera para dibujar */
extern Tnodo * listaAccesible;

/**************** ********* ***************/
/**************** FUNCIONES ***************/
/**************** ********* ***************/

/* --------------------------------------------------------------------------------------- */  
/* UTILACION DEL PLANIFICADOR                                                              */
/* --------------------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------------------- */
/* InitLinePl                                                                              */ 
/*  .... inicializa todo lo relativo al planificador que es oculto                         */ 

extern void InitLinePl();

/* --------------------------------------------------------------------------------------- */
/* PlanLine                                                                                */ 
/*  .... Computa el canal del planificador                                                 */ 
/*  .... In: la matriz, el sistema de referencia de la matriz y el robot en globales       */ 
/*  ....     las coordenadas del goal, y en ElimListas 1 si eliminas la lista dentro o     */
/*           0 si lo haces fuera (para dibujar)                                            */
/*  .... Out: el angulo cuando este                                                        */
/*  .... Return: 0 no ha encontrado camino (time out) y 1 si encontrado                    */

extern int PlanLine(char a[][DIMMATRIZ], 
		    Tsc *sisMat, 
		    Tsc *sisrob,
		    Tpf *goal, 
		    float *angLinePl, 
		    int ElimListas);

#endif
