/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *       					  'l l _ c o m  _ h'
 *
 *                                      
 *
 *  File 'll_com.h'       								by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "errno.h"
#include <pthread.h>
#include "core/include/definitions.h"
#include "core/interface/wmp_protected_interface.h"
#include "core/interface/wmp_interface.h"
#include "core/include/wmp_misc.h"


///*** MARTE OS ********/////
#include <sys/pci.h>
#include "../drivers/yenta-funciona-hardwired/yenta_socket.h"
#include "../drivers/rt61/rt61-interface.h"

#define RT2561_VENDOR   0x1814
#define RT2561_DEVICE   0x0302

// #define PCI_VENDOR_ID_RICOH             0x104C
 #define PCI_DEVICE_ID_TI_AC56    0xAC56
 
static void pause(){
   char key;
   printf(" press Enter...");
   key = getchar();
}
// -----------------------------------------------------------------------
static void msg(char *s){
    printf(s);
    pause();
}

///*** MARTE OS ********/////

int readllcfg(){
	return 1;
}

void closeLowLevelCom(){
}

int initLowLevelCom(){
	printf("Inicializo el rt61\n");	
	///*** MARTE OS ********/////
	 static struct pci_device dev, *dev_p, *pci_bridge_dev;
    struct pci_device_id id;
    uint8_t byte;
    uint32_t dword;

    // 1.- FIND the cardbus bridge
    dev_p = &dev;
    if (pci_find_device(PCI_VENDOR_ID_TI, PCI_DEVICE_ID_TI_AC56, NULL, dev_p)) {
        printf("BRIDGE not found\n");
       // return -1;
    }
    printf("BRIDGE found\n");

    // 2.- Set it as bus master and adjust latency
    adjust_pci_device(dev_p);
    printf("BRIDGE Adjusted!\n");

    // 3.- Assign BUS numbers
    dev_p->primary = 0;        /* number of primary bridge */
    dev_p->secondary = 2;      /* number of secondary bridge */
    dev_p->subordinate = 5;     /* max number of subordinate buses */

    // 4.- Read its base address
    pci_read_config_dword(dev_p, PCI_BASE_ADDRESS_0, &dword);
    printf("BRIDGE read base address: %X (find device: %X, linux:0xD7821000)\n", dword, dev_p->membase);
//     dev_p->membase = dword;
    dev_p->membase = 0x24000000;
    //pause();
    // 5.- Install YENTA driver, activating the socket!
    if (yenta_probe (dev_p, &id)) {
        printf("ERROR en yenta_probe\n");
        //return -1;
    }
    printf("YENTA activated\n");

    pci_read_config_byte(dev_p, PCI_CB_PRIMARY_BUS, &byte);
    printf("BRIDGE primary bus: %u\n", byte);
    pci_read_config_byte(dev_p, PCI_CB_CARD_BUS, &byte);
    printf("BRIDGE card bus: %u\n", byte);
    pci_read_config_byte(dev_p, PCI_CB_SUBORDINATE_BUS, &byte);
    printf("BRIDGE subordinate bus: %u\n", byte);
    printf("BRIDGE IRQ: %d\n",dev_p->irq);

    printf("config space of CARDBUS\n");
    show_pci_config_space(dev_p->bus, dev_p->devfn);
    //pause();

     // 7.- Configure ralink memory, irq
//     pcibios_write_config_dword(2, 0, PCI_BASE_ADDRESS_0, 0x14000000);
    pcibios_write_config_dword(2, 0, PCI_BASE_ADDRESS_0, 0x22000000);
    pcibios_read_config_dword(2, 0, PCI_BASE_ADDRESS_0, &dword);
    pcibios_write_config_byte(2, 0, PCI_INTERRUPT_LINE, dev_p->irq);
    pcibios_read_config_byte(2, 0, PCI_INTERRUPT_LINE, &byte);
    pcibios_write_config_dword(2, 0, PCI_COMMAND, 0x04100012);
    pcibios_write_config_dword(2, 0, PCI_CACHE_LINE_SIZE, 0x00004010);


    printf("config space of RALINK\n");
    show_pci_config_space(2, 0);
    //pause();

   wifi_frame_t frame;
   int i;
   unsigned char buff [MAX_DATA_SIZE];

//   mac_address mac_dest = {0x00, 0x80, 0x5A, 0x39, 0x88, 0xAE};
   mac_address mac_dest = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};


   msg ("ACK TEST for RT61 Module (CHECK IF I RECEIVE an ACK)");

   if (rt61_init (6, 27)){//27
    	printf("ERROR en rt61_init\n");
      return -1;
   }
		
	printf("Fin inicialización\n");
	    //pause();
//	printf("el rt61 debe estar incializado\n");
	return 1;
}

int llsend(char * f,int size){
	mac_address mac_dest = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
//	printf("Envio algo\n");
	f[0] = 69;
	f[1] = 69;	
	mssleep(5);
	if (rt61pci_send (f, size, mac_dest) < 0)
		return -1;
	return 1;
}

int llreceive(char *f,int timeout)
{
	
	wifi_frame_t frame;
	mac_address addr;
	long int t1, t2;
	int read_bytes;
	struct timespec abs_timeout, copia;
	
	timeout = 1000*1000*300;

	long int aux;

	
//	printf("Recibo algo\n");

	 	clock_gettime (CLOCK_REALTIME, &abs_timeout);
	 	//abs_timeout.tv_nsec += timeout * 1000 * 1000 * 1000;  
	 	//abs_timeout.tv_sec += 1;
	 	
//	 	//*****************************************************
//	 	/// AÑADIR TIMEOUT A VARIABLE TIEMPO ACTUAL
//	 	//total en nanosegundos
//	 	aux = abs_timeout.tv_sec * 1000*1000*1000 + abs_timeout.tv_nsec; 
//	 	
//	 	//sumamos nanosegundos de timeout
//	 	aux = aux + timeout;
//	 	
//	 	//volvemos a poner los valores en sec y nsec
//	 	abs_timeout.tv_sec = aux / 1000*1000*1000;
//	 	abs_timeout.tv_nsec = aux - (abs_timeout.tv_sec *1000*1000*1000);
//	 	//*****************************************************	 	
	 	
	 	//timeout tiene que ser menor que 1 segundo!!!
	 	aux = abs_timeout.tv_nsec + timeout;
	 	if (abs_timeout.tv_nsec + timeout >= 1000*1000*1000){ //se ha desbordado
	 		abs_timeout.tv_sec += 1;
	 		abs_timeout.tv_nsec = abs_timeout.tv_nsec + timeout - 1000*1000*1000;
	 	}else{//no ha desbordado
	 		abs_timeout.tv_nsec = abs_timeout.tv_nsec + timeout;
	 	}
	 	//abs_timeout.tv_sec += 1;
	 	copia = abs_timeout;
	 while (1){
	 	if (rt61pci_recv (&frame, &abs_timeout) < 0){
	 		//printf("expira timeout!!\n");
	 		return EXPIRED;
	 	}	
		abs_timeout = copia;
//	 	rt61pci_frame_getSourceMac (&frame, addr);
         read_bytes = rt61pci_frame_getData (&frame, f, 1500);
	 	 if (f[0] == 69 && f[1]==69){
	 	    //printf("PARA MI!!!!!!!!!\n");
	 	  	return RECEIVE_OK;
	 	 } 	
	 	 else{
	 	 	//printf("NO ES PARA MI!!!!!!!!!\n");
	 	 	//pause();
	 	 }
	 }

	return EXPIRED; 
}
