/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *       					  'w m p G U I  _ h'
 *
 *                                      
 *
 *  File 'wmpGUI.h'       				by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/

#include <ncurses.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <semaphore.h>
#include <stdarg.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include "core/include/definitions.h"
#include "core/interface/wmp_protected_interface.h"

//static int errfd;
//static int pipp[2];
//static int firstTime=1;
static int GUI=1;
static int N_NODES;
static sem_t semt;
static WINDOW *lqmWin,*lqmWinBorder,*lowWin,*leftWin,*rightWin,*lowWinBorder,*leftWinBorder,*rightWinBorder,*infoWin,*infoWin2;
WINDOW *create_newwin(int height, int width, int starty, int startx){
	WINDOW *local_win;
	local_win = newwin(height, width, starty, startx);
	box(local_win,0,0);//'|', '-');			 					 
	wrefresh(local_win);	
	return local_win;
}

void initGUI(int mode,int numNodes);

void  INTResize(int sig){
	signal(SIGWINCH, SIG_IGN);
	endwin();
	refresh();
	initGUI(2,N_NODES);
}

void initGUI(int mode,int numNodes){
	N_NODES=numNodes;
	GUI=mode;	
	if (GUI<2) return;
	/* Redirect stderr to rt-wmp GUI */
	//pipe(pipp);
	//close(2);
	//errfd=dup(pipp[1]);
	//fcntl (pipp[0], F_SETFL, O_NONBLOCK);
	
	sem_init(&semt,0,1);
	endwin();
	initscr();			/* Start curses mode*/
	cbreak();			/* Line buffering disabled, Pass on*/
	nonl();
    intrflush(stdscr, FALSE);
    keypad(stdscr, TRUE);
	refresh();
	int bottomH=LINES /3;
	int bottomW=COLS;
	lowWinBorder = create_newwin(bottomH, bottomW-(N_NODES*4)-4, LINES-bottomH, 0);
	lowWin = newwin(bottomH-2, bottomW-(N_NODES*4)-6, (LINES-bottomH)+1, 1);
	
	lqmWinBorder=create_newwin(bottomH, N_NODES*4+3, LINES-bottomH, bottomW-(N_NODES*4)-3);
		//lowWin = newwin(bottomH-2, bottomW-2, (LINES-bottomH)+1, 1);
	
	lqmWin = newwin(bottomH-2, N_NODES*4+1, (LINES-bottomH)+1, bottomW-(N_NODES*4)-2);
	
	int leftH=LINES-bottomH-3;
	int leftW=COLS /2;
	
	leftWinBorder = create_newwin(leftH,leftW, 0, 0);
	leftWin= newwin(leftH-2,leftW-2, 1, 1);
	
	int rightH=leftH;
	int rightW=COLS-leftW-1;
	
	rightWinBorder = create_newwin(rightH,rightW, 0, leftW+1);
	rightWin= newwin(rightH-2,rightW-2, 1, leftW+2);
	
	
	create_newwin(3,COLS,(LINES-bottomH)-3,0);
	int infoW=15;//COLS/3;
	infoWin=newwin(1,infoW,(LINES-bottomH)-2,1);
	infoWin2=newwin(1,COLS-infoW-2,(LINES-bottomH)-2,infoW+1);
	
	scrollok(lowWin,1);
	scrollok(leftWin,1);
	scrollok(rightWin,1);
		
	wprintw(leftWinBorder,"Messages");
	wrefresh(leftWinBorder);
	wprintw(rightWinBorder,"Broadcast Messages");
	wrefresh(rightWinBorder);
	wprintw(lowWinBorder,"Debug Messages");
	wrefresh(lowWinBorder);
	wprintw(lqmWinBorder,"Local");
	wrefresh(lqmWinBorder);
	
	wrefresh(lowWin);
	signal(SIGWINCH, INTResize);	
}


int wmprintf(int win,const char *format, ...){
  
  if (GUI==0) return 0;  
  char s[512];
  va_list arg;
  int done;
  va_start (arg, format);
  done = vsprintf (&s[0], format, arg);
  va_end (arg);
  
 if (GUI==1 || win==TTY) {
  	fprintf(stderr,s);
  	return 0;  
 }
 sem_wait(&semt);
  char *idx;
  switch (win) {
  case TOPLEFT: 
  	wprintw(leftWin,s);
 	wrefresh(leftWin);
  	break;
  case TOPRIGHT: 
  	wprintw(rightWin,s);
  	wrefresh(rightWin);
  	break;
  case BOTTOM: 
  	wprintw(lowWin,s);
  	wrefresh(lowWin);
  	break;
  case MIDLEFT:
    idx=strstr(s, "\n");
    if (idx!=NULL){
    	*idx=0;idx++;*idx=0;
    } 
  	mvwprintw(infoWin,0,0,s);
  	wrefresh(infoWin);
  	break;
  case MIDRIGHT: 
	idx=strstr(s, "\n");
    if (idx!=NULL){
    	*idx=0;idx++;*idx=0;
    } 
  	mvwprintw(infoWin2,0,0,s);
  	wrefresh(infoWin2);
  	break; 
  case LQM: 
	mvwprintw(lqmWin,0,0,s);
  	wrefresh(lqmWin);
  	break;
  }
 /* Redirect stderr */
 //char err[256];
 //read(pipp[0],err,256);
 // wprintw(lowWin,err);  
  sem_post(&semt);
  return 0;
}

void exitGUI(){
	endwin();
}
void resizeGUI(){
}

