/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *       					  'w m p I n i t _ h'
 *
 *                                      
 *
 *  File 'wmpInit.h'       				by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/

#include <string.h>
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include "core/interface/wmp_protected_interface.h"
#include "core/include/global.h"

int wmpReadConfiguration(Status * status){
	int i,j;
	char param[30],val[20];
	FILE *f;
	f=fopen(".//rt-wmp.cfg","r");
	if (f==0) {
		wmprintf(TTY,"File rt-wmp.cfg not found.\nExiting.\n",0,0);
		getchar();
		exitGUI();
		exit(1);
	}	 	
	status->UC_INTERRUPT=0;
	status->BC_INTERRUPT=0;
	status->GUI=1;
	status->perHopDelay=0;	
	status->haveFakeLQM=0;
	status->sents=0;
	status->drops=0;
	status->id=0;
	status->maxPerNodeRetries=0;
	status->maxTotalRetries=0;
	status->ENHANCED_DROP=0;
	status->FALLDOWN_TO_RECEIVE=0;
	status->SORT=1;
	status->TIMEOUT=100;
	status->rssi_capable=1;
	status->DEBUG_LEVEL=0;
	status->DEBUG_OUTPUT=0;
	status->DEBUG_TYPE=0;
	status->max_rssi=100;
	status->hold_time=1000;
	status->quiet=0;
	status->mobile_average_elements=50;
	status->acknow=-1;
	wmprintf(TTY,"Reading Configuration file->->->"); 
	while (fscanf(f,"%s %s",param,val)!=EOF){
		if (strcmp(param,"#")==0) continue;  
		if (strcmp(param,"WMP_ADDRESS")==0){
			status->id=atoi(val);
		}
		if (strcmp(param,"N_NODES")==0){
			status->N_NODES=atoi(val);
		}
		if (strcmp(param,"QUIET")==0){
			status->quiet=atoi(val);
		}
		if (strcmp(param,"MAX_RSSI")==0){
			status->max_rssi=atoi(val);
		}
		if (strcmp(param,"BC_INTERRUPT")==0){
			status->BC_INTERRUPT=atoi(val);			
		}
		if (strcmp(param,"UC_INTERRUPT")==0){
			status->UC_INTERRUPT=atoi(val);			
		}
		if (strcmp(param,"DEBUG_ADDR")==0){
			strcpy(status->DEBUG_ADDR,val);
		}
		if (strcmp(param,"TIMEOUT")==0){
			status->TIMEOUT=atoi(val);			
		}
		if (strcmp(param,"HOLD_TIME")==0){
			status->hold_time=atoi(val);
		}
		if (strcmp(param,"DEBUG_LEVEL")==0){
			status->DEBUG_LEVEL=atoi(val);
		}
		if (strcmp(param,"DEBUG_TYPE")==0){
			status->DEBUG_TYPE=atoi(val);
		}
		if (strcmp(param,"DEBUG_OUTPUT")==0){
			status->DEBUG_OUTPUT=atoi(val);
		}
		if (strcmp(param,"FALLDOWN_TO_RECEIVE")==0){
			status->FALLDOWN_TO_RECEIVE=atoi(val);
		}
		if (strcmp(param,"MAX_PER_NODE_RETRIES")==0){
			status->maxPerNodeRetries=2;//atoi(val);
		}
		if (strcmp(param,"MAX_TOTAL_RETRIES")==0){
			status->maxTotalRetries=2;//atoi(val);
		}
		if (strcmp(param,"PRIORITY_BASED")==0){
			status->SORT=atoi(val);
		}
		if (strcmp(param,"ENHANCED_DROP")==0){
			status->ENHANCED_DROP=atoi(val);
		}
		if (strcmp(param,"GUI")==0){
			status->GUI=atoi(val);
		}
		if (strcmp(param,"PER_HOP_DELAY")==0){
			status->perHopDelay=atoi(val);
		}
		if (strcmp(param,"RSSI_CAPABLE")==0){
			status->rssi_capable=atoi(val);
		}
		if (strcmp(param,"MOBILE_AVERAGE_ELEMENTS")==0){
			status->mobile_average_elements=atoi(val);
		}
		if (strcmp(param,"FAKE_LQM")==0){
			status->haveFakeLQM=1;
			int idx=0;
			for (i=0;i<status->N_NODES;i++){				
				for (j=0;j<status->N_NODES;j++){
					status->fakeLQM[i][j]=80*(val[idx]=='1');
					idx++;				
				}
			}			
		}
	}
	wmprintf(TTY,"Done->\n");
	return 0;
}
