/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *                      'M o b i l e A v e r a g e _ c'
 *
 *                                      
 *
 *  File 'MobileAverage.c'                     			by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with RT-WMP;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
#include "include/MobileAverage.h"

void mobile_avg_free(MobileAverage * e){
	FREE(e->elem);
}
void mobile_avg_init(MobileAverage * e, int n_elements){
	e->elem=(char *) MALLOC(n_elements*sizeof(char));
	e->n_elements=n_elements;
	e->seen=0;
	e->idx=0;
	e->initialized=0;
	e->avgd_value=100; /* or 0 better */
};
	
void mobile_avg_new_value(MobileAverage*e, char val){
	int i;
	double avg=0;
	e->seen=getActualTime();
	if (!e->initialized){
		for (i=0;i<e->n_elements;i++){
			e->elem[i]=val;		
		}
		e->avgd_value=val;
		e->initialized=1;
	} else {		 	
		e->elem[e->idx]=val; 
		e->idx++;
		if (e->idx>=e->n_elements) e->idx=0;
		e->idx=(e->idx+1) % e->n_elements;
		for (i=0;i<e->n_elements;i++){
			avg+=(1.0*e->elem[i]);	
		}
		avg=avg/e->n_elements;
		e->avgd_value= (char) avg;			
	}
};
	
void mobile_avg_reset(MobileAverage* e){
	e->initialized=0;
	e->avgd_value=0;
};
char mobile_avg_get_averaged_value(MobileAverage * e){
	return e->avgd_value;
};

long mobile_avg_get_age(MobileAverage * e){
	return (getActualTime()-e->seen);
};	
