/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *       				  'd e f i n i t i o n s  _ h'
 *
 *                                      
 *
 *  File 'wmpGUI.h'       								by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with RT-WMP;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
 
#ifndef DEFINITIONS__H
#define DEFINITIONS__H

#include <stdio.h>
#include "core/interface/Msg.h"



/*FUNCTION RETURN CODE*/
#define RECEIVE_OK  44
#define ERROR		-99		/*generic error*/
# define EXPIRED	-2
#define UNDEF		-1

/*STATES*/
#define EVALUATE 					10
#define EVALUATE_DISCOVER			11
#define EVALUATE_TOKEN				12
#define EVALUATE_AUTHORIZATION		13
#define EVALUATE_MESSAGE			14
#define EVALUATE_DROP_TOKEN			15
#define EVALUATE_FOREIGN			16

#define TO_EXPIRED					20
#define TO_DISCOVER_EXPIRED			21
#define TO_TOKEN_EXPIRED			22
#define TO_AUTHORIZATION_EXPIRED	23
#define TO_MESSAGE_EXPIRED			24

#define NEW_TOKEN					32
#define WAIT_ACK					33					
#define SEND						34
#define RETRY						35
#define RECEIVE						36
#define DUPLICATE_TOKEN				37

#define NET_INACTIVITY 65

#define ABORT						-1

/* RT-WMP Extensions */
#define NO_EXTESION					0
#define NERUS						1
#define PLUS						2



/* PROGRAM STATUS*/
typedef struct  {
/* Node ID and working Parameters*/
	int id;
	char N_NODES; 
	long timeout;
	int hold_time;
/* Working Buffers*/ 
	char rxBuff[MTU];
	char buffer[MTU];
	char sendBak[MTU];
/*Local Information*/
	struct Averages *avg;
	unsigned long highestSerial;	
	int lastSentType;
	int retries;
	int maxPerNodeRetries;
	int maxTotalRetries;
	unsigned long LACK;
	int waitRemaining;
	int alive;
	char acknow;	
/*Configuration Parameters*/
	int ENHANCED_DROP;
	int FALLDOWN_TO_RECEIVE;
	int SORT;
	int TIMEOUT;
	int GUI;
	int UC_INTERRUPT;
	int BC_INTERRUPT;
	int perHopDelay;
	int rssi_capable;
	int max_rssi;
/* Debugging Parameters*/	
	long long recvTime;
	char **fakeLQM;
	int haveFakeLQM;
	long sentMsg;
	long sents;
	long drops;
	long receivedMsg;
	long long timeStart;
	long globalReceivedMsg;
	char DEBUG_ADDR[20];
	char DEBUG_OUTPUT;
	char DEBUG_LEVEL;
	char DEBUG_TYPE;
	/* new */
	int quiet;
	int mobile_average_elements;
}Status;

#endif
