/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *                   		  'i n t e r f a c e _ c'
 *
 *                                      
 *
 *  File 'interface.c'                     				by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with RT-WMP;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/

#include <stdarg.h>
#include "include/global.h"
#include "include/lqm.h"
#include "interface/wmp_protected_interface.h"


char wmpGetNodeId(){
	return status.id;
}

char wmpGetNumOfNodes(){
	return status.N_NODES;
}

int wmpGetLatestLQM(char * lqm){
	int k=0,i=0,j=0;
	for (i=0;i<status.N_NODES;i++){
		for (j=0;j<status.N_NODES;j++){			
			lqm[k]=lqm_get_val(i,j);
			k++;
		}
	}
	return k;
}

void wfprintf(FILE* f, const char *format, ...){ 
  char s[200];
  va_list arg;
  int done;
  va_start (arg, format);
  done = vsprintf (&s[0], format, arg);
  va_end (arg);
  wmprintf(BOTTOM,s);
}
