/* X7 X6 X5 X4 X3 X2 X1 X0
* X4 X3 X2 X1 X0 => Node that have to search
* X5 : 1 : BC Reached
* X6 : 1 : Lost
* X7 : 0 Unreached 1: Reached
*/
#include "include/nstat.h"
unsigned char * nstat;

void  init_nstat(int size){
	int i;
	nstat=MALLOC(sizeof(char)*size);	
	for (i=0;i<size;i++){
		nstat[i]=0;
	}
	fprintf(stderr,"Initalized nstat size:%d",size);
}
void  free_nstat(){
	FREE(nstat);		
}

/* BIT FUNCTIONS */
void set_bit(unsigned char *a, unsigned char n){
   *a |= (1 << n);
}
int test_bit(unsigned char e, unsigned char n){
   e = e & (1 << n);
   return (e>0);
}

void clear_bit(unsigned char *b, unsigned char n){
   *b &= ~(1 << n);
}
void set_if_set(unsigned char src, unsigned char *dst,unsigned char n){
	if (test_bit(src,n)){
		set_bit(dst,n);
	} else{
		clear_bit(dst,n);
	}
}

/* EXPORTED FUNCTIONS */

void nstat_set_val(int idx, unsigned char id){
   	int i;
   	unsigned char *val=&nstat[idx];
   	unsigned char tmp=*val;
   	*val=id;
   	for (i=5;i<8;i++){
		set_if_set(tmp,val,i);
   	}
   	val=&id;
}
unsigned char nstat_get_val(int idx){
   	int i;
   	unsigned char val=nstat[idx];
   	for (i=5;i<8;i++){
		clear_bit(&val,i);
   	} 
   	return val;
}
int nstat_isReached(int idx){
   unsigned char val=nstat[idx];
   return test_bit(val,7);
}
int nstat_isLost(int idx){
   unsigned char val=nstat[idx];
   return test_bit(val,6);
}
int nstat_isReachedBC(int idx){
	unsigned char val=nstat[idx];	
    return test_bit(val,5);
}
void nstat_clearReached(int idx){
	unsigned char *val=&nstat[idx];
    return clear_bit(val,7);
}
void  nstat_setReached(int idx){
    unsigned char *val=&nstat[idx];
    set_bit(val,7);
}
void nstat_clearReachedBC(int idx){
   unsigned char *val=&nstat[idx];
   clear_bit(val,5);
}
void  nstat_setReachedBC(int idx){
   unsigned char *val=&nstat[idx];
   set_bit(val,5);
}
void  nstat_setLost(int idx){
   unsigned char *val=&nstat[idx];
   set_bit(val,6);
}
void  nstat_clearLost(int idx){
   unsigned char *val=&nstat[idx];
   clear_bit(val,6);
} 

char nstat_get_byte(int idx){
	return (char) nstat[idx];
}
void nstat_set_byte(int idx,char val){
	nstat[idx]=(unsigned char) val;
}

