//#include "definitions.h"
#include "config/compiler.h"
#include "core/include/global.h"
#include "core/include/nstat.h"
#include <string.h>
#include "extensions/broadcast/interface/bc_manage_broadcast.h"
#include "extensions/broadcast/common/bc_queues.h"
#include "bc_frames.h"
#include "extensions/broadcast/interface/wmp_bc_interface.h"
//#include <assert.h>

char maxPri;
char protocol;
unsigned short len;
int data_is_valid;
int preemptive=0;

/* BIT FUNCTIONS */
void iset_bit(unsigned int *a, unsigned char n){
   *a |= (1 << n);
}
int itest_bit(unsigned int e, unsigned char n){
   e = e & (1 << n);
   return (e>0);
}

void iclear_bit(unsigned int *b, unsigned char n){
   *b &= ~(1 << n);
}
void iset_if_set(unsigned int src, unsigned int *dst,unsigned char n){
	if (itest_bit(src,n)){
		iset_bit(dst,n);
	} else{
		iclear_bit(dst,n);
	}
}

void clean_bc_reached(){
	int i;
	for (i=0;i<status.N_NODES;i++){
		nstat_clearReachedBC(i);
	}
}

int am_I_in (Simple_bc * p){ 
	return itest_bit(p->dest,status.id);
}

int bc_check_finished(Simple_bc * p){ 
	return (p->dest==0);
}

void bc_token_received(wmpFrame *t){
	fprintf(stderr,"Token rcvd\n");
	char * tkn_data_ptr =(char*)t;
	if (t->hdr.type==TOKEN){
		tkn_data_ptr+=(sizeof(Token_Hdr)+sizeof(Token)+status.N_NODES*status.N_NODES);
	}
	else if	(t->hdr.type==AUTHORIZATION){
		tkn_data_ptr+=sizeof(Token_Hdr)+sizeof(Authorization);
	}else if	(t->hdr.type==MESSAGE){
		tkn_data_ptr+=sizeof(Token_Hdr)+sizeof(Message)+t->msg.len;
	}else ASSERT(0);
		
	Simple_bc * sbc= (Simple_bc *) tkn_data_ptr;
	//char * data_ptr =tkn_data_ptr + sizeof(Simple_bc);
	char myMaxPri=getHighestPriorityInTxBCQueue();
	long myMaxPriAge=getHighestPriorityAgeInTxBCQueue();		
	int carryMsg = (t->hdr.bc_len>0);
	int queueNotEmpty = (getNumOfElementInTXBCQueue()>0);
	int morePriority = queueNotEmpty && (myMaxPri > sbc->maxPri || (myMaxPri == sbc->maxPri && myMaxPriAge > sbc->age));	
	int transmit = queueNotEmpty;
	fprintf (stderr,"Carry Msg??? %d\n",carryMsg);
	if (carryMsg){
		if (am_I_in(sbc)){
			Msg m; m.src=sbc->idMaxPri;	m.priority=sbc->maxPri;
			m.len=sbc->len;	m.dest=sbc->dest;
			memcpy(m.data,&sbc->data,m.len);
			fprintf (stderr,"MSG RECEIVED len:%d %s\n",len,&sbc->data);
			pushRcvdBCMsg(&m);
		}			
		nstat_setReachedBC(status.id); //TODO:REMOVE
		iclear_bit(&sbc->dest,status.id);	 	
		fprintf(stderr,"Antes Can transmit\n");
		int bc_finished = carryMsg && bc_check_finished(sbc);
		if (bc_finished){
			t->hdr.bc_len=0;
			clean_bc_reached(); //TODO:REMOVE
			sbc->acknow=status.id;
		}		
		transmit&=((bc_finished) || (preemptive && morePriority));
	}
	
	if (transmit){
		fprintf(stderr,"Can transmit\n");
		//clean_bc_reached();//todo:remove
		//nstat_setReachedBC(status.id); //todo:remove
		Msg m;		
		popBCMsgToSend(&m);		
		sbc->maxPri=m.priority; 
		sbc->len=m.len;
		sbc->idMaxPri=m.src; 
		iclear_bit(&m.dest,status.id);
		sbc->dest=m.dest;		
		memcpy(&sbc->data,m.data,m.len);
		t->hdr.bc_len=sizeof(Simple_bc)+m.len;
	}
	len=t->hdr.bc_len;
	//memcpy(bc_data,tkn_data_ptr,len);
}



/* NOT USED ALREADY*/
void bc_save_token(wmpFrame *t){
	char * tkn_data_ptr =(char*)t;
	tkn_data_ptr+=(sizeof(Token_Hdr)+sizeof(Token)+status.N_NODES*status.N_NODES);	
	Simple_bc * sbc= (Simple_bc *) tkn_data_ptr;
	fprintf(stderr,"Guardo Token %d\n",getNumOfFreePositionsInTXBCQueue());
	Msg m;
	m.dest=sbc->dest;
	m.len=sbc->len;
	m.priority=sbc->maxPri;
	m.src=sbc->idMaxPri;
	memcpy(&m.data[0],&sbc->data,sbc->len);
	PushBCMsgToSend(&m);
	fprintf(stderr,"Guardado Token %d\n",getNumOfFreePositionsInTXBCQueue());
}
void bc_create_new_token(wmpFrame *t){
	fprintf(stderr,"New Token\n");
	if (t->hdr.type!=TOKEN){} //NOT EXISTING FIELDt->tkn.len=0;
//	char * data_ptr =(char*)t;
//	data_ptr+=(sizeof(Token_Hdr)+sizeof(Token)+status.N_NODES*status.N_NODES);
	//t->tkn.len=0;
//	memcpy(data_ptr,bc_data,len);
}
