#include "common/include/Queue.h"
#include "core/interface/wmp_interface.h"
Queue_t ** mq_queues;
int nqueues;

void init_mq_Queues(int n){
	int i;
	mq_queues = (Queue_t **) MALLOC(n*sizeof(Queue_t*));
	for (i=0;i<n;i++){
		mq_queues[i]=(Queue_t *) MALLOC(sizeof(Queue_t));	
		initQueue(mq_queues[i],50,FIFO,REPLACE, "mq");
	}
	nqueues=n;
}

void free_mq_Queues(){
	int i;
	for (i=0;i<nqueues;i++){
		free(mq_queues[i]);	
	}
	free(&mq_queues);
}

void mq_event_pushed_msg(Msg * m){
	while(wmpGetNumOfElementInRXUCQueue()>0){
		Msg m;
		wmpPopUCMsg(&m);
		int port=m.port;
		if (port <0 || port >nqueues) port=0;
		pushMsg(mq_queues[port],&m);
	}
}

int wmp_mq_getNumOfElementsInQueue(unsigned int n){
	n= (n>nqueues ? 0 : n); 	
	return getNumOfElemInQueue(mq_queues[n]);
}

void wmp_mq_pop(unsigned int n, Msg * m){
	n= (n > nqueues ? 0 : n); 	
	popMsg(mq_queues[n],m);
}

void wmp_mq_push(unsigned int n,Msg * m){
	n= (n > nqueues ? 0 : n); 	
	m->port=n;
	pushMsg(mq_queues[n],m);
}
